<?php
    
    /*
    overwrite PHP setting
    error_reporting(E_ALL & ~E_NOTICE & E_DEPRECATED & E_STRICT);//display or not-display errors
    */
    ini_set('display_errors', 0);ini_set('display_startup_errors', 0);error_reporting(E_ALL & ~E_NOTICE);
    ini_set("pcre.backtrack_limit", "10000000");//for PdfToText to process large PDf or with graphics; default is 1000000
    putenv("TZ=Asia/Kuala_Lumpur");//set time zone 
    date_default_timezone_set('Asia/Kuala_Lumpur');//set time zone
    
    //database connection properties           
    $dbhost = "localhost";
	$dbname = "insert_db_name_here";
	$dbuser = "insert_db_username_here";
    $dbpass = "insert_db_password_here";

    /*
    you will need to very careful and do not change the $password_aes_key mid way when using the system as your user not be able to login unless you revert back to the old key.
    set this once and never again edit it.
    to change this value, follow this steps (only when first time configuring the system):
    1. login to the system as admin 
    2. leave the system but DO NOT LOG OUT
    3. edit config.php (or config.user.php) file on the server and change the $password_aes_key with something harder
    4. go to Change Password page. as admin, you do not have to input old password just input a new password
    5. logout and login with the new password.
    */
    $password_aes_key = "45C799DB3EBC65DFBC69A0F36F605E6CA2447CD519C50B7DA0D0D45D2B0F2431";
    
    /*
    system running mode live|demo|maintenance 
    in 'demo' mode: password changing, user management module will be disabled.
    in 'maintenance' mode: the searcher and user portion of this system will be disabled.    
    */
    $system_mode = "live";    

    //set installed date for this IR
    $installed_date = "2020-10-02";//must be the original installed date of sWadah, repository data will cannot be any lower than this YYYY-MM-dd
    
    //system title
    $system_title = "Pustaka sWADAH";

    //system identifier (preferaby a domain)
    $system_identifier = "swadah.upsi.edu.my";

    /*
    repository url (mention the subdirectory, if applicable)
    must begin with http:// or https:// and end with /
    */
    $system_domain = "http://localhost/my/swadah/";

    //repository policy url
    $system_policy_url = "http://localhost/my/swadah/";

    //admin email
    $system_admin_email = "asyrani@upsi.edu.my";

    //registered owner
    $system_owner = "Unit Server & Pembangunan Aplikasi";

    //helpdesk info for more information
    $system_helpdesk_contact = "Unit Server & Pembangunan Aplikasi support line 05-4506775.";

    //searcher access only on permitted IP addresses/range received by the system
    $ip_restriction_enabled = false;

    //document extension for uploading new item
    $system_docs_directory = "files/docs";//directory without the leading and following /
    $system_allow_document_extension = "pdf";
    $system_allow_document_maxsize = "90000000";//in bytes = 90MB
    $max_allow_parser_to_work = "20000000";//in bytes = 20MB, anything bigger smalot/pdftotext will failed.

    //guest document extension for uploading new item
    $system_pdocs_directory = "files/pdocs";//directory without the leading and following /
    $system_allow_pdocument_extension = "pdf";
    $system_allow_pdocument_maxsize = "20000000";//in bytes = 20MB
    $allow_guestpdf_insert_by_admin = true;//allow guest file input on the input page

    //index extension for uploading new item
    $system_txts_directory = "files/txts";//directory without the leading and following /
    $system_allow_txt_extension = "txt";
    $system_allow_txt_maxsize = "10000000";//in bytes = 10MB
    $allow_txt_insert_by_admin = true;//allow text file input on the input page
    
    //image attachment extension for uploading new item
    $system_albums_directory = "files/albums";//directory without the leading and following /
    $system_allow_imageatt_extension = "jpg,jpeg";
    $system_allow_imageatt_maxsize = "10000000";//in bytes = 10MB
    $allow_image_insert_by_admin = true;//allow image file input on the input page

    /*
    default view for input : simple | marc
    please select either marc or simple on first run. you may experience data lost if try to convert to one another midway of using this system.
    */
    $default_view_input =  'simple';

    //for paging purposes, how many number per page per resultset
    $system_wide_resultPerPage = 10;

    //use publisher as 
    $publisher_as = "Faculty";
    
    //use subject heading as -  this will utilize/repurpose subject heading for a different means
    $subject_heading_as = "Subject";
    $subject_heading_delimiter = ",";//to be set before any first input of data

    //selectable subject heading : single|multi
    $subject_heading_selectable = "multi";

    //enable access to foundation (selectable input in form of list) : admin|all
    $enable_access_to_itemtype = "admin";
    $enable_access_to_subjectheading = "all";
    $enable_access_to_publisher = "admin";

    //show initial status (hide/show) if hide, default will always be Available-Public
    $init_status_visibility = "show";

    //show subject browser
    $show_subject_browser_guest = true;
    $show_subject_browser_admin = true;

    //allow guest access to full text
    $allow_guest_access_to_ft = false;

    //allow guest access to guest doc / partial text
    $allow_guest_access_to_pt = true;

    //user page
    $allow_user_to_login = true;//allow user to login to their page
    $allow_user_to_register =  false;//future use

    //searcher
    $searcher_button_visibility = true;
    $searcher_marker_to_hide = "(IR)";//default = null (in use when copying from eprints import)

	//index2 and searcher page index configuration
    $index2_back_to_top_icon = false; // show back to top mini icon on the admin search page for results
    $searcher_back_to_top_icon = false;// show back to top mini icon on guest search page for results
    $searcher_show_icon_indicator = false;// show (true) or hide (false) indicators on guest search page for results

    //enable download mobile app (for pro package client only)
    $enable_swadah_mobileapp_qrdownload = false;
    $app_apk_url = "files/apks/sWADAH_UPSI.apk";

    //enabled full text/abstract composer in add new / update
    $default_is_abstract = true;//true|false
    $enable_fulltext_abstract_composer = true;
    $fulltext_abstract_composer_type = "richtext";//simpletext|richtext
    $strip_tags_fulltext_abstract_composer = true;//remove html tags on display

    //enabled reference composer in add new / update
    $enable_reference_composer = true;
    $reference_composer_type = "richtext";//simpletext|richtext
    $strip_tags_reference_composer  = false;//remove html tags on display

    //accession number and control number visibility
    $show_accession_number = true;
    $show_control_number = true;

    /*
    item delete method : permanent | takecover
    permanent: item and all its resources will be deleted entirely from the system
    takecover : item will be set to undiscoverable and resources will be renamed to <filename>.<extension>.deleted
    */
    $delete_method = "permanent";

    /*
    pdf to text conversion engine : pdftotext | smalot
    pdftotext = very basic pdf to text conversion engine but cannot work with some pdf converter. very fast engine.
    smalot = advanced pdf to text conversion. require the webserver to install composer and re-update the smalot/pdfparser module before using. not a fast engine but works with all pdf converters.
    */
    $pdftxt_engine = "smalot";

    /*
    cataloguing tag formatting
    setting 'show' to 'false' will render the field with an empty data even if you have put in data in it prior setting it to 'false'
    please be caution and make sure to finalize your tags selection via institution policy on the first entry of data
    */

    //38isbnissn 020
    $tag_020_simple = "ISBN";    
    $tag_020 = "$tag_020_simple <span style='color:green;'>020</span>";    
    $tag_020_show = true;

    $tag_022_simple = "ISSN";
    $tag_022 = "$tag_022_simple <span style='color:green;'>022</span>";
    $tag_022_show = true;

    //38langcode 041
    $tag_041_simple = "Language Code";
    $tag_041 = "$tag_041_simple <span style='color:green;'>041</span>";
    $tag_041_inputtype = "select"; //keyin|select
    $tag_041_selectable = "zsm|eng|chi|tam|ara";//values must be separated by |
    $tag_041_selectable_default = "zsm";//values must one of the above value
    $tag_041_show = true;

    //38localcallnum 090
    $tag_090_simple = "Call Num";
    $tag_090 = "$tag_090_simple <span style='color:green;'>090</span>";
    $tag_090_show = true;

    //38author 100
    $tag_100_simple = "Main Author";
    $tag_100 = "$tag_100_simple <span style='color:green;'>100</span>";

    //38title 245
    $tag_245_simple = "Title";
    $tag_245 = "$tag_245_simple <span style='color:green;'>245</span>";

    //38edition 250
    $tag_250_simple = "Edition";
    $tag_250 = "$tag_250_simple <span style='color:green;'>250</span>";
    $tag_250_show = true;

    //38publication 264
    $tag_264_simple = "Publication";
    $tag_264 = "$tag_264_simple <span style='color:green;'>264</span>";
    $tag_264_show = true;
    $tag_264_a_default = "Tanjong Malim";

    //38physicaldesc 300
    $tag_300_simple = "Physical Description";
    $tag_300 = "$tag_300_simple <span style='color:green;'>300</span>";
    $tag_300_show = true;

    //38series 490
    $tag_490_simple = "Series";
    $tag_490 = "$tag_490_simple <span style='color:green;'>490</span>";
    $tag_490_show = true;

    //38notes 500
    $tag_500_simple = "Notes";
    $tag_500 = "$tag_500_simple <span style='color:green;'>500</span>";
    $tag_500_hint = "";
    $tag_500_show = true;

    //38dissertation_note 500
    $tag_502_simple = "Degree Type";
    $tag_502 = "Dissertation Note <span style='color:green;'>502</span>";
    $tag_502_show = true;
    $tag_502_inputtype = "select"; //keyin|select
    $tag_502_b_selectable = "Doctoral|Masters|First Degree|Diploma|Others";//values must be separated by |
    $tag_502_b_selectable_default = "First Degree";//values must one of the above value

    //38restriction 506 -available for depositor mode only
    $tag_506_simple = "Access Category";
    $tag_506 = "$tag_500_simple <span style='color:green;'>506</span>";
    $tag_506_hint = "";
    $tag_506_show = true;

    //41subjectheading 650
    $tag_650_simple = 'Subject Entry - Topical Term';
    $tag_650 = "$tag_650_simple <span style='color:green;'>650</span>";
    $tag_650_show = true;

    //38pname 700 (max. 10)
    $tag_700_simple = "Additional Authors";
    $tag_700 = "$tag_700_simple <span style='color:green;'>700</span>";
    $tag_700_show = true;

    //38source 710
    $tag_710_simple = "Corporate Name";
    $tag_710 = "$tag_710_simple <span style='color:green;'>710</span>";
    $tag_710_show = true;
    $tag_710_a_default = "Universiti Pendidikan Sultan Idris";

    //38location 852
    $tag_852_simple = "Location";
    $tag_852 = "$tag_852_simple <span style='color:green;'>852</span>";
    $tag_852_show = true;

    //38link 856
    $tag_856_simple = "HTTP Link";
    $tag_856 = "$tag_856_simple <span style='color:green;'>856</span>";
    $tag_856_show = true;

    //OAI-PMH oai pmh policy statement for this repository
    $enable_oai_pmh = true;//oai-pmh enabler. true = enabled OAI-PMH request, false = disable
    $oai_rights = "closedAccess"; //openAccess | restrictedAccess | closedAccess | embargoedAccess
    $oai_main_language = "eng"; //must be in ISO 639-3 format
    $oai_main_format = "text";

    //SEARCHER API
    $enable_searcher_api = true;//enable or disable access to SEARCHER API

    //DEPOSIT ENTRY
    //for declaration
    $system_dfile_directory = "files/depos/d";//directory without the leading and following /
    $system_allow_dfile_extension = "pdf";
    $system_allow_dfile_maxsize = "10000000";//in bytes = 10MB
    //for full text
    $system_pfile_directory = "files/depos/p";//directory without the leading and following /
    $system_allow_pfile_extension = "pdf";
    $system_allow_pfile_maxsize = "100000000";//in bytes = 100MB
    //misc for user deposit
    $hide_main_author = true;
    $hide_additional_authors_entry = true;
    $enable_user_deposit = true;
    
    //allow access to depositor page. will also provide admin to manage user deposit and depositor account management
    $allow_depositor_function = true;
    //allow submission of item declaration
    $allow_declaration_submission = true;
    //allow abstract submission
    $allow_abstract_submission = true;
    //enable date of publication input
    $show_dateof_publication = false;
    //set how many deposit can per user submit. to set unlimited, simply set 9999
    $limit_amount_userdeposit = 1;

    //document viewer and downloader
    $max_download_allowed = "3";//the number of count digital document will be available before it is expired (per user session)
    $max_time_link_availability = "86400";//duration in seconds on which the digital document will be available before it is expired.

    /*
    xpdf module for displaying pdf pages number
    refer to includes/xdf directory for which version of pdfinfo to use in your server
    must be absolute path to pdfinfo executable provided in swadah
    for linux eg : "/usr/share/pdfinfo32";
    for windows eg : "D:\\xpdf\\win\\pdfinfo32.exe";
    */
    $usePdfInfo = true;
    $pdfInfoCmd = "D:\\xampp\\htdocs\\swadah\\includes\\xpdf\\win\\pdfinfo32.exe";
                        
    /*
    PHPMAILER Settings
    you will need to set smtp information here on fields that were left empty
    */
    $emailMode = "ssl";
    $emailHost = "smtp.gmail.com";
    $emailPort = 465;
    $emailUserName = "insert_gmail_email_address_here";//this is usually the email address as username
    $emailPassword = "insert_gmail_password_here";
    $emailSetFrom = "insert_gmail_email_address_here";//this is usually an email address, but you can changed it to something else if you want your user to reply to specific email address
    $emailSetFromName = "sWADAH Mailer";
    $emailFooter = "<hr>This is an automated email. Please do not reply to this email. If you have any question regarding your submission, contact us at pustakasys@upsi.edu.my";

    //set the default password to reset whenever reset password tool is used
    $default_password_if_forgotten = "1";

    //search debugging mode yes|no
    $debug_search = "no";

    //ezproxy_ip //set your ezproxy ip server here (if you have no ezproxy server, just type in your server ip address here)
    $ezproxy_ip = "10.16.0.23";

    //copyright info
    $copyright_info = "This material may be protected under Malaysia Copyright Act which governs the making of photocopies or reproductions of copyrighted materials.<br/>You may use the digitized material for private study, scholarship, or research.";

    //load user configuration file (optional). to enable, create the config.user.php file and uncomment below. this user config file must be set before database connection engine and build.php lines below.
    //include ('config.user.php');

    //do not alter the contents of these two include files. 
    //please make sure that if you ever do config.user.php, do not include these files.
    include ('build.php');//load version information
    include ('conn.db.php');//load database connection engine
 
?>